routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('auth.login');
});

Auth::routes([
  'register' => false, // Registration Routes...
  'reset' => false, // Password Reset Routes...
  'verify' => false, // Email Verification Routes...
]);

Route::group(['middleware' => ['auth']], function() {
    Route::resource('roles','RoleController');
    Route::resource('users','UserController');
    Route::resource('projects','ProjectController');
    Route::resource('tasks','TaskController');
    Route::resource('comments','CommentController');
    Route::resource('logworks','LogworkController');
    
    ROute::get('changestatusproject/{id}/{pid}','ProjectController@changeStatus');
    Route::get('logworkremoved/{id}','LogworkController@is_removed');
    Route::get('download-logworks/{name}','LogworkController@download');
    Route::get('commentremoved/{id}','CommentController@is_removed');
    Route::get('download-comments/{name}','CommentController@download');
    Route::get('create-task/{id}','TaskController@createTicket');
    Route::get('task/{id}','TaskController@index');
    Route::get('download-attachemnt/{name}','TaskController@download');
});

Route::get('/home', 'HomeController@index')->name('home');
Route::resource('yourwork','YourworkController');
Route::get('projectExcel','ProjectController@excel');
Route::get('userBlock/{id}','UserController@userBlock');
Route::get('editUser/{id}','UserController@editUser');
Route::put('updateUser/{id}','UserController@updateUser');
Route::get('changePassword/{id}','UserController@changePassword');
Route::put('updatePassword/{id}','UserController@updatePassword');
Route::resource('logs','LogController');
Route::get('download/{filename}', 'LogController@getDownload');
// LocalizationController
Route::get('lang/{locale}', 'LocalizationController@index');
// ROUTE for getImage from photos folder
Route::get('/photos/{filename}', function ($filename)
{
    $path = storage_path() . '/photos/' . $filename;
    if(!File::exists($path)) abort(404);
    $file = File::get($path);
    $type = File::mimeType($path);
    $response = Response::make($file, 200);
    $response->header("Content-Type", $type);
    return $response;
})->name('photo');

app/Project.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Project extends Model
{
    protected $fillable = [
        'key', 'project','user_id','description','status',
    ];

    public function users()
    {
        return $this->belongsToMany('App\User');
    }
}

app/Http/Controllers/ProjectController.php
<?php

namespace App\Http\Controllers;

use App\Project;
use App\User;
use App\ProjectUser;
use App\Task;
use App\Comment;
use Auth;
use Illuminate\Http\Request;
use DB;
use View;
use App\LogActivity;

class ProjectController extends Controller
{
    function __construct()
    {
         $this->middleware('permission:project-list|project-create|project-edit|project-delete', ['only' => ['index','show']]);
         $this->middleware('permission:project-create', ['only' => ['create','store']]);
         $this->middleware('permission:project-edit', ['only' => ['edit','update']]);
         $this->middleware('permission:project-delete', ['only' => ['destroy']]);
    }
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {  
            $projects = DB::table('projects')
                    ->select('*')
                    ->join('project_user','project_user.project_id','=','projects.id')
                    ->where('project_user.user_id', Auth::User()->id)
                    ->paginate(10);
        return view('projects.index',compact('projects'))
                    ->with('i', (request()->input('page', 1) - 1) * 10);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $users = User::select('id', 'name')->get();
        return view('projects.create',compact('users'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {

        request()->validate([
            'key' => 'required',
            'project' => 'required',
            'user_id' => 'required',
            'description' => 'required',
        ]);

        $input = $request->all();
        $project= new Project();
            $project->key= $input['key'];
            $project->project= $input['project'];
            $project->user_id= $input['uid'];
            $project->description= $input['description'];
            $project->status= "0";
            $project->created_by = $input['created_by'];
        $project->save();
        
        $project->users()->sync($input['user_id']);

        $notification = array(
            'message' => 'Project has been created successfully.', 
            'title' => 'Message',
            'alert-type' => 'success',
            'alert' => 'toast-primary'
        );

        \LogActivity::addToLog('Project: '.$input['project'],Auth::User()->id,Auth::User()->name,'Create',$input['description']);

        return redirect()->route('projects.index')->with($notification);
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Project  $project
     * @return \Illuminate\Http\Response
     */

    public function show(Project $project)
    {
        $project = Project::find($project['id']);

        $tasks = DB::table('tasks')
        ->select('*')
        ->where('project_id',$project['id'])
        ->get();
        
        $users = $project->users()
			->orderBy('name', 'asc')
			->get();

        return view('projects.show',compact('users','project','tasks'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Project  $project
     * @return \Illuminate\Http\Response
     */
    public function edit(Project $project)
    {
        $userall = User::select('id', 'name')->get();
        $project = Project::find($project['id']);
        $users = $project->users()
			->orderBy('name', 'asc')
			->get();

        return view('projects.edit',compact('users','project','userall'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Project  $project
     * @return \Illuminate\Http\Response
     */
    
    public function update(Request $request, Project $project)
    {
        request()->validate([
            'key' => 'required',
            'project' => 'required',
            'user_id' => 'required',
            'description' => 'required',
        ]);
        $input = $request->all();
        $project= Project::find($project['id']);
            $project->key= $input['key'];
            $project->project= $input['project'];
            $project->user_id= $input['uid'];
            $project->description= $input['description'];
            $project->created_by = $input['created_by'];
        $project->save();        

        $project->users()->sync($input['user_id']);
        $notification = array(
            'message' => 'Project has been updated successfully.', 
            'alert-type' => 'success',
        );
        \LogActivity::addToLog('Project: '.$input['project'],Auth::User()->id,Auth::User()->name,'Update',$input['description']);

        return redirect()->route('projects.index')->with($notification);
    }

    public function changeStatus($id,$pid)
    {
        $project= Project::find($pid);
            $project->status= $id;
        $project->save();  

        \LogActivity::addToLog('Project: '.$project->project,Auth::User()->id,Auth::User()->name,'Update','Status: '.$id);

        $notification = array(
            'message' => 'You have been changed status successfully.', 
            'alert-type' => 'success',
        );
        return back()->with($notification);
    }
    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Project  $project
     * @return \Illuminate\Http\Response
     */
    public function destroy(Project $project)
    {
//         $brand = Brand::find(1);
// $brand->products()->delete();
    }

    public function excel()
	{
        $formal_data = DB::table('projects')
            ->join('users','users.id','=','projects.user_id')
            ->select('projects.key','projects.project','users.name as member','projects.description',
            'projects.status','projects.created_by','projects.created_at')
            ->get()->toArray();
        //dd($formal_data);
		$programma_array[] = array('key', 'project', 'member', 'description', 'status',
		'created_by', 'created_at');
			
		foreach($formal_data as $pass)
		{
			$programma_array[] = array
			(
			'key'  => $pass->key,
			'project'   => $pass->project,
			'member'    => $pass->member,
				
      		);
			
		}
		
			
			Excel::create('Programma_Data', function($excel) use ($programma_array)
			{
				$excel->setTitle('Apotelesmata');
				$excel->sheet('Programma_Data', function($sheet) use ($programma_array)
				{
					$sheet->fromArray($programma_array, null, 'A4', false, false);
				});
			}) -> download('xlsx');
    }
}

resources/views/projects/create.blade.php
@extends('layouts.app') @section('content-wrapper')
<div class="content-header">
    <div class="container-fluid">
        <div class="row mb-2">
            <div class="col-sm-6">
                <h1 class="m-0 text-dark">{{ __('veacha.button_new_project')}}</h1>
            </div>
            <!-- /.col -->
            <div class="col-sm-6">
                <ol class="breadcrumb float-sm-right">
                    @can('role-create')
                    <li class="breadcrumb-item"><a href="{{ route('projects.index') }}" class="btn btn-primary m-0 pull-left">{{ __('veacha.button_list_project')}}</a>
                    </li>
                    @endcan
                </ol>
            </div>
        </div>
    </div>
</div>
@endsection @section('content')
<div class="container-fluid">
    <div class="row">
        <div class="col-lg-12 col-12">
            @if ($errors->any())
                <div class="alert alert-danger">
                    <strong>Whoops!</strong> There were some problems with your input.<br><br>
                    <ul>
                        @foreach ($errors->all() as $error)
                            <li>{{ $error }}</li>
                        @endforeach
                    </ul>
                </div>
            @endif
            <div class="card">
                <div class="card-body table-responsive">
                    <form role="form" action="{{ route('projects.store') }}" method="POST" enctype="multipart/form-data">
                        {{csrf_field()}}
                        <div class="row">
                            <div class="col-xs-4 col-sm-4 col-md-4">
                                <div class="form-group">
                                    <strong>{{ __('veacha.key') }} <i class="text-red">*</i></strong>
                                    <input type="text" name="key" value="{{ old('key') }}" class="form-control form-control-sm" style="text-transform:uppercase" placeholder="Enter key">
                                </div>
                            </div>
                            <div class="col-xs-4 col-sm-4 col-md-4">
                                <div class="form-group">
                                    <strong>{{ __('veacha.project') }} <i class="text-red">*</i></strong>
                                    <input type="text" name="project" value="{{ old('project') }}" class="form-control form-control-sm" placeholder="Enter project name">
                                </div>
                            </div>
                            <div class="col-xs-4 col-sm-4 col-md-4">
                                <div class="form-group">
                                    <strong>{{ __('veacha.member')}} <i class="text-red">*</i></strong>
                                    <br>
                                    <select name="user_id[]" class="select2" multiple="multiple" class="form-control form-control-sm" data-placeholder="Select members" style="width: 100%; display: block;">
                                        @foreach ($users as $user)
                                        <option value="{{ $user->id }}">{{ $user['name'] }}</option>
                                        @endforeach
                                    </select>
                                </div>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-xs-4 col-sm-4 col-md-4">
                                <div class="form-group">
                                    <strong>{{ __('veacha.description') }} <i class="text-red">*</i></strong>
                                    <textarea class="form-control form-control-sm" name="description" rows="3" placeholder="Place some text here">{{ old('description') }}</textarea>
                                    
                                </div>
                            </div>
                            {{-- <div class="col-xs-12 col-sm-12 col-md-12">
                                <div class="form-group">
                                    <strong>Description <i class="text-red">*</i></strong>
                                    <textarea class="textarea" name="description" rows="50" placeholder="Place some text here"
                                style="width: 100%; height: 200px; font-size: 14px; line-height: 18px; border: 1px solid #dddddd; padding: 10px;"></textarea>
                                </div>
                            </div> --}}
                        </div>
                        <div class="row">
                            <div class="col-xs-12 col-sm-12 col-md-12">
                                <div class="form-group">
                                    <input type="hidden" name="created_by" value="{{ Auth::user()->name }}">
                                    <input type="hidden" name="uid" value="{{ Auth::user()->id }}">
                                    <button type="submit" class="btn btn-primary">{{ __('veacha.button_save_project')}}</button>
                                </div>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/projects/edit.blade.php
@extends('layouts.app') @section('content-wrapper')
<div class="content-header">
    <div class="container-fluid">
        <div class="row mb-2">
            <div class="col-sm-6">
                <h1 class="m-0 text-dark">{{ __('veacha.project')}}</h1>
            </div>
            <!-- /.col -->
            <div class="col-sm-6">
                <ol class="breadcrumb float-sm-right">
                    @can('role-create')
                    <li class="breadcrumb-item"><a href="{{ route('projects.index') }}" class="btn btn-primary m-0 pull-left">{{ __('veacha.button_list_project')}}</a>
                    </li>
                    @endcan
                </ol>
            </div>
        </div>
    </div>
</div>
@endsection @section('content')
<div class="container-fluid">
    <div class="row">
        <div class="col-lg-12 col-12">
            @if ($errors->any())
                <div class="alert alert-danger">
                    <strong>Whoops!</strong> There were some problems with your input.<br><br>
                    <ul>
                        @foreach ($errors->all() as $error)
                            <li>{{ $error }}</li>
                        @endforeach
                    </ul>
                </div>
            @endif
            <div class="card">
                <div class="card-body table-responsive">
                    <form role="form" action="{{ route('projects.update',$project->id) }}" method="POST" enctype="multipart/form-data">
                        {{ csrf_field() }}
                        {{ method_field('PATCH') }}
                        <div class="row">
                            <div class="col-xs-6 col-sm-6 col-md-6">
                                <div class="form-group">
                                    <strong>{{ __('veacha.key')}} <i class="text-red">*</i></strong>
                                <input type="text" name="key" class="form-control form-control-sm" style="text-transform:uppercase" placeholder="Enter key" value="{{ $project->key}}">
                                </div>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-xs-6 col-sm-6 col-md-6">
                                <div class="form-group">
                                    <strong>{{ __('veacha.project')}} <i class="text-red">*</i></strong>
                                    <input type="text" name="project" class="form-control form-control-sm" placeholder="Enter project name" value="{{ $project->project}}">
                                </div>
                            </div>
                        </div>
                        {{-- <div class="row">
                            <div class="col-xs-4 col-sm-4 col-md-4">
                                <div class="form-group">
                                    <strong>{{ __('veacha.status')}} <i class="text-red">*</i></strong>
                                    <select name="status" class="select2" class="form-control form-control-sm" data-placeholder="Select members" style="width: 100%; display: block;">
                                        <option value="0" {{ $project->status === 0 ? 'selected' : '' }}>Todo</option>
                                        <option value="1" {{ $project->status === 1 ? 'selected' : '' }}>In-progress</option>
                                        <option value="2" {{ $project->status === 2 ? 'selected' : '' }}>Completed</option> 
                                    </select>
                                </div>
                            </div>
                        </div> --}}
                        <div class="row">
                            <div class="col-xs-6 col-sm-6 col-md-6">
                                <div class="form-group">
                                    <strong>{{ __('veacha.member')}} <i class="text-red">*</i></strong>
                                    <select name="user_id[]" class="select2" multiple="multiple" class="form-control form-control-sm" data-placeholder="Select members" style="width: 100%; display: block;">
                                        @foreach ($userall as $user)
                                        <option value="{{ $user->id }}" {{ $user->id == $project->user_id ? 'selected' : '' }}>{{ $user['name'] }}</option>
                                        @endforeach
                                    </select>
                                </div>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-xs-6 col-sm-6 col-md-6">
                                <div class="form-group">
                                    <strong>{{ __('veacha.description') }} <i class="text-red">*</i></strong>
                                <textarea class="form-control form-control-sm" name="description" rows="3" placeholder="Place some text here">{{ $project->description}}</textarea>
                                    
                                </div>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-xs-12 col-sm-12 col-md-12">
                                <div class="form-group">
                                    <input type="hidden" name="created_by" value="{{ Auth::user()->name }}">
                                    <input type="hidden" name="uid" value="{{ Auth::user()->id }}">
                                    <button type="submit" class="btn btn-primary">{{ __('veacha.button_update_project')}}</button>
                                </div>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/projects/show.blade.php
@extends('layouts.app') @section('content-wrapper')
<div class="content-header">
    <div class="container-fluid">
        <div class="row mb-2">
            <div class="col-sm-6">
                <h1>{{ __('veacha.project')}}</h1>
            </div>
            <!-- /.col -->
            <div class="col-sm-6">
                <ol class="breadcrumb float-sm-right">
                    @can('project-edit')
                    <li class="breadcrumb-item"><a href="{{ route('projects.edit',$project->id) }}" class="btn btn-primary m-0 pull-left">{{ __('veacha.button_edit_project')}}</a>
                    </li>
                    @endcan
                    @can('project-list')
                    <li class="breadcrumb-item"><a href="{{ route('projects.index') }}" class="btn btn-primary m-0 pull-left">{{ __('veacha.button_list_project')}}</a>
                    </li>
                    @endcan
                </ol>
            </div>
        </div>
    </div>
</div>
@endsection @section('content')
<div class="container-fluid">
    <div class="row">
        <div class="col-lg-12 col-12">
            <div class="">
                <div class="">
                    <div class="row">
                        <div class="col-xs-6 col-sm-6 col-md-6">
                            <dl class="row">
                                <dt class="col-sm-4">{{ __('veacha.project_name') }}: </dt>
                                <dd class="col-sm-8">{{ $project->project }}</dd>
                                <dt class="col-sm-4">{{ __('veacha.key')}}: </dt>
                                <dd class="col-sm-8" style="text-transform:uppercase">{{ $project->key}}</dd>
                                <dt class="col-sm-4">{{ __('veacha.created_by')}}: </dt>
                                <dd class="col-sm-8">{{ $project->created_by}}</dd>
                                <dt class="col-sm-4">{{ __('veacha.created_at')}}: </dt>
                                <dd class="col-sm-8" style="text-transform:uppercase">{{ $project->created_at->format('d/m/Y h:i A') }}</dd>
                            </dl>
                        </div>
                        <div class="col-xs-6 col-sm-6 col-md-6">
                            <dl class="row">
                                <dt class="col-auto" style="margin-top: 5px;">{{ __('veacha.status')}}: </dt>
                                <dd class="col-sm-10 float-right">
                                    <button type="button" class="btn btn-primary dropdown-toggle col-sm-4" data-toggle="dropdown">
                                        @if($project->status === 0) Open
                                        @elseif($project->status === 1) Invalid
                                        @elseif($project->status === 2) Duplicate
                                        @else Close @endif
                                    </button>
                                    @can('user-edit')
                                    <div class="dropdown-menu">
                                        <a class="dropdown-item" href="{{ url('changestatusproject/0',$project->id) }}">Open</a>
                                        <a class="dropdown-item" href="{{ url('changestatusproject/1',$project->id) }}">Invalid</a>
                                        <a class="dropdown-item" href="{{ url('changestatusproject/2',$project->id) }}">Duplicate</a>
                                        <a class="dropdown-item" href="{{ url('changestatusproject/3',$project->id) }}">Close</a>
                                    </div>
                                    @endcan
                                </dd>
                            </dl>
                            <div class="form-group">
                                <strong>{{ __('veacha.member')}}</strong>
                                <div class="clearfix" style="margin-bottom: 5px;"></div>
                                @foreach ($users as $user)
                                <img src="{{ URL::to('/') }}/photos/{{ $user->photo }}" class="img-circle img-size-32" alt="photo" title="{{ $user->name }}"> @endforeach
                            </div>
                        </div>
                    </div>
                    <hr>
                    <dl class="row">
                        <dt class="col-auto">{{ __('veacha.description')}}: </dt>
                        <dd class="col-sm-8">{{ $project->description}}</dd>
                    </dl>
                </div>
            </div>

            <hr>
            <br>
            <div class="row">
                <div class="col-12 col-md-12 col-xs-12 col-sm-12">
                    <div class="card">
                        <div class="card-header">
                            <h3 class="card-title">{{ __('veacha.task_list') }}</h3>
                            <div class="float-right">
                            @can('task-create')<a href="{{ url('create-task',$project->id) }}" class="btn btn-sm btn-primary">{{ __('veacha.button_new_task') }}</a>@endcan
                            </div>
                        </div>
                        <div class="card-body table-responsive">
                            <div class="input-group input-group-sm" style="width: 250px;border: 1px solid #ced4da;">
                                <input type="text" name="table_search" class="form-control float-right" id="searchTask" style="border: 0px;" placeholder="Search task ...">

                                <div class="input-group-append">
                                    <button type="submit" class="btn btn-default"><i class="fas fa-search"></i></button>
                                </div>
                            </div>
                            
                            <br>
                            <table class="table table-bordered table-hover">
                                <thead>
                                    <tr>
                                        <th width="50px">{{ __('veacha.no')}}</th>
                                        <th>{{ __('veacha.task')}}</th>
                                        {{-- <th>{{ __('veacha.status')}}</th> --}}
                                        <th>{{ __('veacha.created_by')}}</th>
                                        <th>{{ __('veacha.created_at')}}</th>
                                    </tr>
                                </thead>
                                <tbody id="task">
                                    @foreach ($tasks as $i => $ticket)

                                    <tr href="{{ route('tasks.show',$ticket->id) }}">
                                        <td>{{ ++$i }}</td>
                                        <td>{{ $ticket->task }}</td>
                                        {{-- <td>{{ $ticket->status }}</td> --}}
                                        <td>{{ $ticket->created_by }}</td>
                                        <td>{{ $ticket->created_at }}</td>
                                    </tr>

                                    @endforeach
                                </tbody>
                            </table>
                            <br>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection @section('js')
@include('notification') 
<script>
    $(function () {
        $('table tbody tr').click(function(){
            window.location = $(this).attr('href');
            return false;
        });
        $('table tr').css('cursor', 'pointer');
        $("#searchTask").on("keyup", function() {
            var value = $(this).val().toLowerCase();
            $("#task tr").filter(function() {
            $(this).toggle($(this).text().toLowerCase().indexOf(value) > -1)
            });
        });
        $('.dropdown-item').click(function(){
            //alert($(this).attr('href'));
            window.location = $(this).attr('href');
            return false;
        });
    });
</script>
@endsection